SystemOrganization addCategory: #MetaProgramacion!

Object subclass: #MissingImplementorsFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!MissingImplementorsFinder class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/23/2013 20:15'!
class: aClass implements: aCompiledMethod
	| theRealClass |
	 theRealClass := (self isClassMethod: aCompiledMethod) ifTrue: [ aClass theMetaClass ] ifFalse: [ aClass ].
	^ theRealClass methodDictionary at: aCompiledMethod selector ifPresent: [:anAssoc | (anAssoc value isAbstract) not ] ifAbsent: [ false ]! !

!MissingImplementorsFinder class methodsFor: 'private' stamp: 'EtchegoyenLajePulver 6/23/2013 20:32'!
classOfMethod: aCompiledMethod 
	| aClass |
	aClass := aCompiledMethod classBinding value.
	aClass isMeta ifTrue: [ aClass := aClass allInstances at: 1 ].
	^ aClass! !

!MissingImplementorsFinder class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/23/2013 20:03'!
hierarchyFrom: aLeafClass Until: aParentClass implements: aCompiledMethod
	(self class: aLeafClass implements: aCompiledMethod) ifTrue: [ ^ true ].
	^ aLeafClass = aParentClass ifTrue: [  false ]
	ifFalse: [ self hierarchyFrom: aLeafClass superclass Until: aParentClass implements: aCompiledMethod ].! !

!MissingImplementorsFinder class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/23/2013 19:59'!
isClassMethod: aCompiledMethod 
	^ aCompiledMethod classBinding value isMeta! !

!MissingImplementorsFinder class methodsFor: 'enumerating' stamp: 'EtchegoyenLajePulver 6/23/2013 19:28'!
leafSubClassesOfClass: aClass
	^ aClass allSubclasses select: [:aSubClass | aSubClass subclasses isEmpty ]! !

!MissingImplementorsFinder class methodsFor: 'enumerating' stamp: 'EtchegoyenLajePulver 6/23/2013 20:26'!
searchByMethod: aCompiledMethod 
	| aClass leaves |
	aCompiledMethod isAbstract ifFalse: [ ^ Set new ].
	
	aClass := self classOfMethod: aCompiledMethod.
	leaves := self leafSubClassesOfClass: aClass.
	leaves := leaves select: [:aLeaf | (self hierarchyFrom: aLeaf Until: aClass implements: aCompiledMethod) not ].
	
	^ leaves! !

Object subclass: #TestParentClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!TestParentClass class methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 20:44'!
anAbstractClassMethodImplementedInAllLeaves
	^ self subclassResponsibility! !

!TestParentClass class methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:41'!
anAbstractClassMethodImplementedInAllSubClasses
	^ self subclassResponsibility! !

!TestParentClass class methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 20:40'!
anAbstractClassMethodImplementedInMiddleOfHierarchy
	^ self subclassResponsibility ! !

!TestParentClass class methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:36'!
anAbstractClassMethodNotImplemented
	^ self subclassResponsibility! !

!TestParentClass class methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 20:37'!
anAbstractClassMethodNotImplementedInSubSubClasses
	^ self subclassResponsibility! !

!TestParentClass methodsFor: 'implemented methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:02'!
aNonAbstractMethod
	^ true! !

!TestParentClass methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:22'!
anAbstractMethodImplementedInAllLeaves
	^ self subclassResponsibility ! !

!TestParentClass methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:14'!
anAbstractMethodImplementedInMiddleOfHierarchy
	^self subclassResponsibility ! !

!TestParentClass methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:45'!
anAbstractMethodNotImplemented
	^ self subclassResponsibility ! !

!TestParentClass methodsFor: 'abstract methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:00'!
anAbstractMethodNotImplementedInSubSubClasses
	^ self subclassResponsibility ! !

TestParentClass subclass: #TestSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!TestSubClass class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:47'!
anAbstractClassMethodImplementedInAllLeaves
	^ true! !

!TestSubClass class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:09'!
anAbstractClassMethodImplementedInAllSubClasses
	^ true! !

!TestSubClass class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:37'!
anAbstractClassMethodNotImplementedInSubSubClasses
	^ true! !

!TestSubClass methodsFor: 'parent methods implementation' stamp: 'EtchegoyenLajePulver 6/23/2013 19:23'!
anAbstractMethodImplementedInAllLeaves
	^ true! !

!TestSubClass methodsFor: 'parent methods implementation' stamp: 'EtchegoyenLajePulver 6/23/2013 19:01'!
anAbstractMethodNotImplementedInSubSubClasses
	^ true! !

TestParentClass subclass: #TestSubClass2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!TestSubClass2 methodsFor: 'parent methods implementation' stamp: 'EtchegoyenLajePulver 6/23/2013 19:12'!
anAbstractMethodImplementedInMiddleOfHierarchy
	^ true! !

TestSubClass2 subclass: #TestSubSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!TestSubSubClass class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:47'!
anAbstractClassMethodImplementedInAllLeaves
	^ true! !

!TestSubSubClass class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:10'!
anAbstractClassMethodImplementedInAllSubClasses
	^ true! !

!TestSubSubClass class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:40'!
anAbstractClassMethodImplementedInMiddleOfHierarchy
	^ true! !

!TestSubSubClass methodsFor: 'parent methods implementation' stamp: 'EtchegoyenLajePulver 6/23/2013 19:23'!
anAbstractMethodImplementedInAllLeaves
	^ true! !

TestSubClass2 subclass: #TestSubSubClass2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!TestSubSubClass2 class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:47'!
anAbstractClassMethodImplementedInAllLeaves
	^ true! !

!TestSubSubClass2 class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:10'!
anAbstractClassMethodImplementedInAllSubClasses
	^ true! !

!TestSubSubClass2 class methodsFor: 'parent methods implementations' stamp: 'EtchegoyenLajePulver 6/23/2013 20:40'!
anAbstractClassMethodImplementedInMiddleOfHierarchy
	^ true! !

!TestSubSubClass2 methodsFor: 'parent methods implementation' stamp: 'EtchegoyenLajePulver 6/23/2013 19:24'!
anAbstractMethodImplementedInAllLeaves
	^ true! !

TestCase subclass: #MetaProgramacionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:03'!
aNonAbstractMethod
	^ self aTestParentClass methodDictionary at: #aNonAbstractMethod! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:01'!
aTestParentClass
	^ TestParentClass! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:46'!
aTestSubClass
	^ TestSubClass! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:03'!
aTestSubSubClass
	^ TestSubSubClass ! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 20:42'!
anAbstractClassMethodImplementedInAllLeaves
	^ self aTestParentClass theMetaClass methodDictionary at: #anAbstractClassMethodImplementedInAllLeaves! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:49'!
anAbstractClassMethodImplementedInAllSubClasses
	^ self aTestParentClass theMetaClass methodDictionary at: #anAbstractClassMethodImplementedInAllSubClasses! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 20:39'!
anAbstractClassMethodImplementedInMiddleOfHierarchy
	^ self aTestParentClass theMetaClass methodDictionary at: #anAbstractClassMethodImplementedInMiddleOfHierarchy! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:48'!
anAbstractClassMethodNotImplemented
	^ self aTestParentClass theMetaClass methodDictionary at: #anAbstractClassMethodNotImplemented! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 20:37'!
anAbstractClassMethodNotImplementedInSubSubClasses
	^ self aTestParentClass theMetaClass methodDictionary at: #anAbstractClassMethodNotImplementedInSubSubClasses! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:22'!
anAbstractMethodImplementedInAllLeaves
	^ self aTestParentClass methodDictionary at: #anAbstractMethodImplementedInAllLeaves! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:12'!
anAbstractMethodImplementedInMiddleOfHierarchy
	^ self aTestParentClass methodDictionary at: #anAbstractMethodImplementedInMiddleOfHierarchy! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:44'!
anAbstractMethodNotImplemented
	^ self aTestParentClass methodDictionary at: #anAbstractMethodNotImplemented! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 18:59'!
anAbstractMethodNotImplementedInSubSubClasses
	^ self aTestParentClass methodDictionary at: #anAbstractMethodNotImplementedInSubSubClasses! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:16'!
anotherTestSubClass
	^ TestSubClass2 ! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/23/2013 19:04'!
anotherTestSubSubClass
	^ TestSubSubClass2 ! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/19/2013 20:06'!
test01NonAbstractMethodReturnsEmpty
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self aNonAbstractMethod.
	self assert: aCollection isEmpty! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 19:43'!
test02AbstractMethodNotImplementedInSubclassesDoesntReturnEmpty
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractMethodNotImplemented.
	self deny: aCollection isEmpty! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 19:43'!
test03SearchingAbstractMethodNotImplementedInLeafSubclassReturnsSubclass
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractMethodNotImplemented.
	self deny: aCollection isEmpty.
	self assert: (aCollection includes: self aTestSubClass)! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 19:16'!
test04SearchingAbstractMethodNotImplementedInSubSubClassesReturnsOnlySubSubClasses
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractMethodNotImplementedInSubSubClasses.
	self deny: aCollection isEmpty.
	self assert: (aCollection includes: self aTestSubSubClass).
	self assert: (aCollection includes: self anotherTestSubSubClass).
	self deny: (aCollection includes: self aTestSubClass).
	self deny: (aCollection includes: self anotherTestSubClass).! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 19:16'!
test05SearchingAbstractMethodImplementedInMiddleOfHierarchyDoesntReturnLeafClassesOfImplementor
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractMethodImplementedInMiddleOfHierarchy.
	self deny: aCollection isEmpty.
	self assert: (aCollection includes: self aTestSubClass).
	self deny: (aCollection includes: self anotherTestSubClass).
	self deny: (aCollection includes: self aTestSubSubClass).
	self deny: (aCollection includes: self anotherTestSubSubClass).! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 19:21'!
test06SearchingAbstractMethodImplementedInAllLeafSubClassesReturnsEmpty
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractMethodImplementedInAllLeaves.
	self assert: aCollection isEmpty.! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 20:18'!
test07AbstractClassMethodNotImplementedInSubclassesDoesntReturnEmpty
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractClassMethodNotImplemented.
	self deny: aCollection isEmpty! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 20:19'!
test08SearchingAbstractClassMethodNotImplementedInLeafSubclassReturnsSubclass
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractClassMethodNotImplemented.
	self deny: aCollection isEmpty.
	self assert: (aCollection includes: self aTestSubClass)! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 20:35'!
test09SearchingAbstractClassMethodNotImplementedInSubSubClassesReturnsOnlySubSubClasses
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractClassMethodNotImplementedInSubSubClasses.
	self deny: aCollection isEmpty.
	self assert: (aCollection includes: self aTestSubSubClass).
	self assert: (aCollection includes: self anotherTestSubSubClass).
	self deny: (aCollection includes: self aTestSubClass).
	self deny: (aCollection includes: self anotherTestSubClass).! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 20:38'!
test10SearchingClassAbstractMethodImplementedInMiddleOfHierarchyDoesntReturnLeafClassesOfImplementor
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractClassMethodImplementedInMiddleOfHierarchy.
	self deny: aCollection isEmpty.
	self assert: (aCollection includes: self aTestSubClass).
	self deny: (aCollection includes: self anotherTestSubClass).
	self deny: (aCollection includes: self aTestSubSubClass).
	self deny: (aCollection includes: self anotherTestSubSubClass).! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/23/2013 20:41'!
test11SearchingClassAbstractMethodImplementedInAllLeafSubClassesReturnsEmpty
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractClassMethodImplementedInAllLeaves.
	self assert: aCollection isEmpty.! !
